/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Oli Scheuss
 *   Co-authors:
 *      Damian 'Mozork' Frick
 *
 */

#include "PacmanGhostController.h"

#include "PacmanGhost.h"
#include "util/Math.h"

namespace orxonox
{
    // Create the factory for the drone controller.
	RegisterClass(PacmanGhostController);

    /**
    @brief
        Constructor.
    @param context
        The context of this object.
    */
    PacmanGhostRed::PacmanGhostController(Context* context) : Controller(context)
    {
        RegisterObject(PacmanGhostController);
        bool ismoving = false;
        float reltarget_x;
        float reltarget_z;  
        Vector3& actuelposition;     
    }

    /**
    @brief
        Destructor.
    */
    PacmanGhostController::~PacmanGhostController()
    {

    }

    /**
    @brief
        The controlling happens here. This method defines what the controller has to do each tick.
    @param dt
        The duration of the tick.
    */
    void PacmanGhostController::tick(float dt)
    {
        /* NOTE: Ugly hack by Sandro to make the tutorial work for the moment.
         * This will be reverted once the framework update is complete
         */
        //AutonomousDrone *myDrone = static_cast<AutonomousDrone*>(this->getControllableEntity());
        ObjectList<PacmanGhost> objectList;
        ObjectList<PacmanGhost>::iterator it = objectList.begin();
        PacmanGhost* myDrone = *it;

        if (myGhost != nullptr)
        {

            actuelposition = myGhost.getPosition();

            if(actuelposition.x = reltarget_x && actuelposition.z = reltarget_z){
                    ismoving = false;
            }



            if(ismoving){
                moveRightLeft();
                moveFrontBack(); 
            }
        
            else{

                //hashtable

                int random = rand();

                switch(actuelposition) {
                    case 1: if(random % 4 == 0){
                            reltarget_x = 250;
                            reltarget_z = 0;
                            }
                            else if(random % 4 == 1){
                            reltarget_x = 0;
                            reltarget_z = 250;
                            }
                            else if(random % 4 == 2){
                            reltarget_x = 0;
                            reltarget_z = -250;
                            }
                            else if(random % 4 == 3){
                            reltarget_x = -250;
                            reltarget_z = 0;
                            }
                            moving = true;
                    case 2:
                }
            }


        }
    }
}
